package dev.shadowsoffire.apotheosis.ench.enchantments;

import net.minecraft.world.damagesource.DamageSource;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.entity.Entity;
import net.minecraftforge.event.entity.living.ShieldBlockEvent;
import net.minecraftforge.common.ToolActions;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.entity.EquipmentSlot;
import dev.shadowsoffire.apotheosis.ench.EnchModule;
import net.minecraft.world.item.enchantment.Enchantment;

public class ReflectiveEnchant extends Enchantment
{
    public ReflectiveEnchant() {
        super(Enchantment.Rarity.RARE, EnchModule.SHIELD, new EquipmentSlot[] { EquipmentSlot.OFFHAND, EquipmentSlot.MAINHAND });
    }
    
    public int m_6183_(final int enchantmentLevel) {
        return enchantmentLevel * 18;
    }
    
    public int m_6175_(final int enchantmentLevel) {
        return 200;
    }
    
    public int m_6586_() {
        return 5;
    }
    
    public boolean canApplyAtEnchantingTable(final ItemStack stack) {
        return super.canApplyAtEnchantingTable(stack) || stack.canPerformAction(ToolActions.SHIELD_BLOCK);
    }
    
    public void reflect(final ShieldBlockEvent e) {
        final LivingEntity user = e.getEntity();
        final Entity attacker = e.getDamageSource().m_7640_();
        final ItemStack shield = user.m_21211_();
        final int level = shield.getEnchantmentLevel((Enchantment)this);
        if (level > 0 && user.m_9236_().f_46441_.m_188503_(Math.max(2, 7 - level)) == 0) {
            final DamageSource src = user.m_9236_().m_269111_().m_269104_((Entity)user, (Entity)user);
            if (attacker instanceof final LivingEntity livingAttacker) {
                livingAttacker.m_6469_(src, level * 0.15f * e.getBlockedDamage());
                shield.m_41622_(10, user, ent -> ent.m_21166_(EquipmentSlot.OFFHAND));
            }
        }
    }
}
